diff -Naur --exclude=CVS --exclude=configs linux/hpc/hpcproc.c linux-openmosix/hpc/hpcproc.c
--- linux/hpc/hpcproc.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/hpcproc.c	2004-04-13 14:37:43.000000000 +0200
@@ -0,0 +1,2434 @@
+/* Changes since February 12, 2002 copyright by Moshe Bar (moshe@moelabs.com)
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Oren Laadan, Amnon Shiloh, Moshe Bar
+ * Some stuff 'borrowed' from "fs/proc".
+ */
+
+#include <linux/sched.h>
+#include <linux/string.h>
+#include <linux/ctype.h>
+#include <linux/proc_fs.h>
+#include <linux/hpc.h>
+#include <linux/hpcctl.h>
+#include <asm/uaccess.h>
+#include <linux/smp_lock.h>
+#include <hpc/routines.h>
+#include <hpc/defs.h>
+#include <hpc/hpcversion.h>
+#include <linux/swap.h>
+#include <hpc/protocol.h>
+#include <hpc/debug.h>
+#include <hpc/request.h>
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+
+/* general interface */
+
+static int zero = 0;
+static int one = 1;
+static int uintmax = 0x7fffffff;
+
+typedef struct ctl_mosix ctl_mosix;
+
+typedef ssize_t ctl_mosix_t (ctl_mosix *, int, struct file *, void *, size_t *);
+
+struct ctl_mosix {
+	int ctl_name;
+	const char *procname;
+	void *data;
+	int maxlen;
+	mode_t mode;
+	ctl_mosix_t *handler;
+	struct inode_operations *alt_iops;
+	struct file_operations *alt_fops;
+	void *extra[2];
+};
+
+/* values of 'do_intarr' 'write' argument: */
+#define CTLF_SIMPLE	0x01	/* nothing special */
+#define CTLF_UNSIGNED	0x02	/* use unsigned semantics */
+#define CTLF_MINMAXP	0x04	/* use min/max (via pointer) */
+#define CTLF_MINMAXV	0x08	/* use min/max (via values) */
+#define CTLF_BOOLEAN	0x10	/* boolean values (0/1) */
+#define	CTLF_POSITIVE	0x20	/* > 1 */
+
+static void proc_mosix_register(struct proc_dir_entry *de, ctl_mosix *table);
+
+static ssize_t do_intarr(ctl_mosix *, int, struct file*, void *, size_t *, int);
+static inline ssize_t get_intarr(struct file *, const char *, size_t,
+				 struct ctl_mosix *);
+static inline ssize_t put_intarr(struct file *, const char *, size_t,
+				 struct ctl_mosix *);
+
+static inline ctl_mosix_t ctl_boolean;
+static inline ctl_mosix_t ctl_uintarr;
+static inline ctl_mosix_t ctl_positive;
+static inline ctl_mosix_t ctl_minmaxv;
+
+/* dynamic directories: */
+/* the following are Or'ed with the pid/node << 16 */
+enum
+{
+	PROC_REMPID_INO = PROC_MOSIX_USE_START,
+	PROC_REMPID_FROM,
+	PROC_REMPID_GOTO,
+	PROC_REMPID_STATM,
+	PROC_REMPID_STATS,
+	PROC_REMPID_IDENT,
+	PROC_NODEID_INO,
+	PROC_NODEID_CPUS,
+	PROC_NODEID_INFO,
+	PROC_NODEID_LOAD,
+	PROC_NODEID_MEM,
+	PROC_NODEID_RMEM,
+	PROC_NODEID_SPEED,
+	PROC_NODEID_TMEM,
+	PROC_NODEID_STATUS,
+	PROC_NODEID_UTIL,
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	PROC_NODEID_LOADLIMIT,
+	PROC_NODEID_LLIMITMODE,
+	PROC_NODEID_LOADREMOTE,
+	PROC_NODEID_LOADLOCAL,
+	PROC_NODEID_CPULIMIT,
+	PROC_NODEID_CPULIMITMODE,
+	PROC_NODEID_CPUREMOTE,
+	PROC_NODEID_CPULOCAL,
+#endif
+};
+
+struct subnames
+{
+	int id;
+	char *name;
+	int namelen;
+};
+
+struct subnames rempid_subs[] =
+{
+	{PROC_REMPID_FROM, "from", 4},
+	{PROC_REMPID_GOTO, "goto", 4},
+	{PROC_REMPID_STATM, "statm", 5},
+	{PROC_REMPID_STATS, "stats", 5},
+	{PROC_REMPID_IDENT, "identity", 8},
+	{}
+}, nodeid_subs[] =
+{
+	{PROC_NODEID_CPUS, "cpus", 4},
+	{PROC_NODEID_LOAD, "load", 4},
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	{PROC_NODEID_LOADLIMIT, "loadlimit", 9},
+	{PROC_NODEID_LLIMITMODE, "llimitmode", 10},
+	{PROC_NODEID_LOADLOCAL, "loadlocal", 9},
+	{PROC_NODEID_LOADREMOTE,"loadremote", 10},
+	{PROC_NODEID_CPULIMIT, "cpulimit", 8},
+	{PROC_NODEID_CPULIMITMODE, "cpulimitmode", 12},
+	{PROC_NODEID_CPULOCAL, "cpulocal", 8},
+	{PROC_NODEID_CPUREMOTE,"cpuremote", 9},
+#endif
+	{PROC_NODEID_MEM, "mem", 3},
+	{PROC_NODEID_RMEM, "rmem", 4},
+	{PROC_NODEID_SPEED, "speed", 5},
+	{PROC_NODEID_TMEM, "tmem", 4},
+	{PROC_NODEID_STATUS, "status", 6},
+	{PROC_NODEID_UTIL, "util", 4},
+	{}
+};
+
+static ssize_t proc_mosix_sub_read(struct file *, char *, size_t, loff_t *);
+static ssize_t proc_mosix_sub_write(struct file *, const char *, size_t, loff_t *);
+
+static struct file_operations proc_mosix_sub_file_operations =
+{
+	.read = proc_mosix_sub_read,
+	.write = proc_mosix_sub_write,
+};
+
+static struct inode_operations proc_mosix_sub_inode_operations =
+{
+};
+
+static int proc_mosix_sub_readdir(struct file *, void *, filldir_t);
+static struct dentry *proc_mosix_sub_lookup(struct inode *, struct dentry *);
+
+static struct file_operations proc_mosix_subdir_file_operations =
+{
+	.readdir = proc_mosix_sub_readdir,
+};
+
+static struct inode_operations proc_mosix_subdir_inode_operations =
+{
+	.lookup = proc_mosix_sub_lookup,
+};
+
+static int proc_mosix_nodes_readdir(struct file *, void *, filldir_t);
+static struct dentry *proc_mosix_nodes_lookup(struct inode *,struct dentry *);
+
+static struct file_operations proc_mosix_nodes_file_operations =
+{
+	.readdir = proc_mosix_nodes_readdir,
+};
+
+static struct inode_operations proc_mosix_nodes_inode_operations =
+{
+	.lookup = proc_mosix_nodes_lookup,
+};
+
+static int proc_mosix_remote_readdir(struct file *, void *, filldir_t);
+static struct dentry *proc_mosix_remote_lookup(struct inode *,struct dentry *);
+
+static struct file_operations proc_mosix_remote_file_operations =
+{
+	.readdir = proc_mosix_remote_readdir,
+};
+
+static struct inode_operations proc_mosix_remote_inode_operations =
+{
+	.lookup = proc_mosix_remote_lookup,
+};
+
+static struct proc_dir_entry proc_mosix_nodes = {
+        0, 5, "nodes",
+        S_IFDIR | S_IRUGO | S_IXUGO, 2, 0, 0,
+        0, &proc_mosix_nodes_inode_operations,
+	&proc_mosix_nodes_file_operations
+};
+
+static struct proc_dir_entry proc_mosix_remote = {
+        0, 6, "remote",
+        S_IFDIR | S_IRUGO | S_IXUGO, 2, 0, 0,
+        0, &proc_mosix_remote_inode_operations,
+	&proc_mosix_remote_file_operations
+};
+
+static ssize_t proc_mosix_set_remote_goto(struct file*,int,const char*,size_t);
+static int proc_mosix_get_remote_from(struct task_struct *, char *);
+static int proc_mosix_get_remote_stats(struct task_struct *, char *);
+static int proc_mosix_get_remote_identity(struct task_struct *, char *);
+
+static int
+proc_mosix_delete_dentry(struct dentry *dentry)
+{
+	return(1);
+}
+
+static struct dentry_operations proc_mosix_dynamic_dentry_operations =
+{
+	.d_delete = proc_mosix_delete_dentry
+};
+
+/* static directories: */
+
+static inline ssize_t proc_readmosix(struct file*,char*,size_t,loff_t*);
+static inline ssize_t proc_writemosix(struct file*,const char*,size_t,loff_t*);
+
+static struct file_operations proc_mosix_file_operations =
+{
+	.read = proc_readmosix,
+	.write = proc_writemosix,
+};
+
+static loff_t proc_lseekmosixinfo(struct file *, long long, int);
+
+static struct file_operations proc_mosix_info_file_operations =
+{
+	.llseek = proc_lseekmosixinfo,
+	.read = proc_readmosix,
+	.write = proc_writemosix,
+};
+
+/* /proc/hpc/admin: */
+
+enum {
+	ADMIN_CONFIG = 1, ADMIN_STAY, ADMIN_LSTAY, ADMIN_BLOCK, ADMIN_QUIET,
+	ADMIN_NOMFS, ADMIN_EXPEL, ADMIN_BRING, ADMIN_SPEED, ADMIN_SSPEED,
+	ADMIN_OVERHEADS, ADMIN_SLOWDECAY, ADMIN_FASTDECAY, ADMIN_DECAYINTERVAL,
+	ADMIN_GATEWAYS, ADMIN_MOSPE, ADMIN_VERSION,
+#ifdef CONFIG_MOSIX_DFSA
+	ADMIN_DFSALINKS,
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+	ADMIN_MFSCOSTS, ADMIN_MFS_TUNEINFO, ADMIN_MFSKILL,
+#endif /* CONFIG_MOSIX_FS */
+#if CONFIG_MOSIX_LOADLIMIT
+	ADMIN_LOADLIMIT,
+	ADMIN_LLMODE,
+	ADMIN_CPULIMIT,
+	ADMIN_CPULMODE,
+#endif
+};
+
+static ctl_mosix_t ctl_admin_gateways;
+static ctl_mosix_t ctl_admin_mospe;
+static ctl_mosix_t ctl_admin_config;
+static ctl_mosix_t ctl_admin_expel;
+static ctl_mosix_t ctl_admin_bring;
+static ctl_mosix_t ctl_admin_speed;
+static ctl_mosix_t ctl_admin_mode;
+static ctl_mosix_t ctl_admin_slowdecay;
+static ctl_mosix_t ctl_admin_fastdecay;
+static ctl_mosix_t ctl_admin_decayinterval;
+static ctl_mosix_t ctl_admin_overheads;
+static ctl_mosix_t ctl_admin_version;
+#ifdef CONFIG_MOSIX_DFSA
+static ctl_mosix_t ctl_admin_dfsalinks;
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+static ctl_mosix_t ctl_admin_mfskill;
+static ctl_mosix_t ctl_admin_mfscosts;
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_LOADLIMIT
+extern unsigned long load_limit;
+extern unsigned long cpu_limit;
+unsigned long mosadmin_mode_loadlimit = 0;
+unsigned long mosadmin_mode_cpulimit = 0;
+static ctl_mosix_t ctl_admin_loadlimit;
+static ctl_mosix_t ctl_admin_llimitmode;
+static ctl_mosix_t ctl_admin_cpulimitmode;
+static ctl_mosix_t ctl_admin_cpulimit;
+#endif
+static struct ctl_mosix admin_ctl[] = {
+	{ ADMIN_CONFIG, "config", NULL, 0, 0644, ctl_admin_config },
+	{ ADMIN_STAY, "stay", NULL, sizeof(int), 0644, ctl_admin_mode },
+	{ ADMIN_LSTAY, "lstay", NULL, sizeof(int), 0644, ctl_admin_mode },
+	{ ADMIN_BLOCK, "block", NULL, sizeof(int), 0644, ctl_admin_mode },
+	{ ADMIN_QUIET, "quiet", NULL, sizeof(int), 0644, ctl_admin_mode },
+	{ ADMIN_NOMFS, "nomfs", NULL, sizeof(int), 0644, ctl_admin_mode },
+	{ ADMIN_EXPEL, "expel", NULL, 0, 0200, ctl_admin_expel },
+	{ ADMIN_BRING, "bring", NULL, 0, 0200, ctl_admin_bring },
+	{ ADMIN_SPEED, "speed", NULL, sizeof(unsigned long), 0644, ctl_admin_speed },
+	{ ADMIN_SSPEED, "sspeed", &standard_speed, sizeof(int), 0644,
+		ctl_positive },
+	{ ADMIN_OVERHEADS, "overheads", mosix_cost, sizeof(mosix_cost), 0644,
+		ctl_admin_overheads },
+	{ ADMIN_SLOWDECAY, "slowdecay", NULL, sizeof(int), 0644,
+		ctl_admin_slowdecay },
+	{ ADMIN_FASTDECAY, "fastdecay", NULL, sizeof(int), 0644,
+		ctl_admin_fastdecay },
+	{ ADMIN_DECAYINTERVAL, "decayinterval", NULL, sizeof(int), 0644,
+		ctl_admin_decayinterval },
+	{ ADMIN_GATEWAYS, "gateways", NULL, 0, 0644, ctl_admin_gateways },
+	{ ADMIN_MOSPE, "mospe", NULL, 0, 0644, ctl_admin_mospe },
+	{ ADMIN_VERSION, "version", NULL, 0, 0444, ctl_admin_version },
+#ifdef CONFIG_MOSIX_DFSA
+	{ ADMIN_DFSALINKS, "dfsalinks", NULL, 0, 0644, ctl_admin_dfsalinks },
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_FS
+	{ ADMIN_MFSCOSTS, "mfscosts", mfs_cost, sizeof(mfs_cost), 0644,
+		ctl_admin_mfscosts },
+	{ ADMIN_MFSKILL, "mfskill", NULL, 0, 0200, ctl_admin_mfskill },
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	{ ADMIN_LOADLIMIT, "loadlimit", &load_limit, sizeof(unsigned long), 0644,
+		ctl_admin_loadlimit },
+	{ ADMIN_LLMODE, "llimitmode", &mosadmin_mode_loadlimit, sizeof(unsigned long), 
+		0644, ctl_admin_llimitmode },
+	{ ADMIN_CPULIMIT, "cpulimit", &cpu_limit, sizeof(unsigned long), 0644,
+		ctl_admin_cpulimit },
+	{ ADMIN_CPULMODE, "cpulimitmode", &mosadmin_mode_cpulimit, sizeof(unsigned long), 
+		0644, ctl_admin_cpulimitmode },
+#endif
+	{ 0 }
+};
+
+enum {
+	DECAY_CPUJOB = 1, DECAY_IOJOB, DECAY_SLOW, DECAY_FAST, DECAY_OWN,
+	DECAY_INHERIT, DECAY_EXEC, DECAY_EXECONCE, DECAY_CLEAR
+};
+
+/* /proc/hpc/decay: */
+
+static ctl_mosix_t ctl_decay;
+
+static struct ctl_mosix decay_ctl[] = {
+	{ DECAY_CPUJOB,	   "cpujob",   NULL, 0, 0666, ctl_decay },
+	{ DECAY_IOJOB,	   "iojob",    NULL, 0, 0666, ctl_decay },
+	{ DECAY_SLOW,	   "slow",     NULL, 0, 0666, ctl_decay },
+	{ DECAY_FAST,	   "fast",     NULL, 0, 0666, ctl_decay },
+	{ DECAY_OWN,	   "own",      NULL, 0, 0666, ctl_decay },
+	{ DECAY_INHERIT,   "inherit",  NULL, 0, 0666, ctl_decay },
+	{ DECAY_EXEC,	   "exec",     NULL, 0, 0666, ctl_decay },
+	{ DECAY_EXECONCE,  "execonce", NULL, 0, 0666, ctl_decay },
+	{ DECAY_CLEAR,	   "clear",    NULL, 0, 0222, ctl_decay },
+	{ 0 }
+};
+
+/* /proc/hpc/info: */
+enum
+{
+	INFO_CPUS = 1, INFO_INFOS, INFO_LOADS, INFO_MEMS, INFO_RMEMS,
+	INFO_SPEEDS, INFO_TMEMS, INFO_STATA, INFO_UTILS, 
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	INFO_LOADLIMIT,
+	INFO_LLIMITMODE,
+	INFO_LOADLOCAL,
+	INFO_LOADREMOTE,
+	INFO_CPULIMIT,
+	INFO_CPULIMITMODE,
+	INFO_CPULOCAL,
+	INFO_CPUREMOTE,
+#endif
+};
+
+static ctl_mosix_t ctl_info_fill;
+static ctl_mosix_t ctl_info_infos;
+
+static struct ctl_mosix info_ctl[] = {
+	{ INFO_LOADS,	"loads",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_SPEEDS,	"speeds", NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_CPUS,	"cpus",   NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_MEMS,	"mems",   NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_RMEMS,	"rmems",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_TMEMS,	"tmems",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_UTILS,	"utils",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_STATA,	"stata",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_INFOS,	"infos",  NULL, 0, 0444, ctl_info_infos,
+		NULL, &proc_mosix_info_file_operations },
+#ifdef CONFIG_MOSIX_LOADLIMIT
+  	{ INFO_LOADLIMIT,"loadlimit",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_LLIMITMODE,"llimitmode",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_LOADLOCAL,"loadlocal",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_LOADREMOTE,"loadremote",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_CPULIMIT,"cpulimit",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_CPULIMITMODE,"cpulimitmode",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_CPULOCAL,"cpulocal",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+	{ INFO_CPUREMOTE,"cpuremote",  NULL, 0, 0444, ctl_info_fill,
+		NULL, &proc_mosix_info_file_operations },
+#endif
+	{ 0 }
+};
+
+#ifdef CONFIG_MOSIX_DFSA
+static ssize_t
+ctl_admin_dfsalinks(ctl_mosix *ctl, int write, struct file *filp,
+	       void *buf, size_t *len)
+{
+	ssize_t error = 0;
+	int l;
+	char *filename = NULL, c, *e;
+	loff_t pos = filp->f_pos;
+	int done = 0;
+	unsigned int more = 1;
+
+	while(write)
+	{
+		if(!filename && !(filename = __getname()))
+			return(done ? : -ENOMEM);
+		for(e = filename , l = 0 ; l < *len ; l++)
+		if(get_user(c, ((char *)buf)++))
+		{
+			putname(filename);
+			return(done ? : -EFAULT);
+		}
+		else if(c == '\0')
+		{
+			more = 0;
+			*e++ = '\0';
+			break;
+		}
+		else if(c == '\n')
+		{
+			*e++ = '\0';
+			break;
+		}
+		else if(l == PAGE_SIZE-1)
+		{
+			putname(filename);
+			return(done ? : -ENAMETOOLONG);
+		}
+		else
+			*e++ = c;
+		if(l == *len)
+		{
+			putname(filename);
+			return(done ? : -EINVAL);
+		}
+		l = e - filename;
+		if(filename[0] == '-')
+		{
+			if(filename[1])
+				error = dfsa_dellink(&filename[1]);
+			else
+				error = dfsa_clearlinks();
+		}
+		else
+			error = dfsa_addlink(&filename[filename[0] == '+']);
+		putname(filename);
+		if(error)
+			return(done ? : error);
+		pos += l;
+		filp->f_pos = pos;
+		done += l;
+		if(!more || !(*len -= l))
+			return(done);
+	}
+	/* READ */
+	if(!*len)
+		return(0);
+	if(!(filename = dfsa_showlinks()))
+		error = -ENOMEM;
+	else if(pos < (l = strlen(filename)))
+	{
+		filename += pos;
+		l -= pos;
+		if(l > *len)
+			l = *len;
+		if(copy_to_user(buf, filename, l))
+			error = -EFAULT;
+		else
+			*len = l;
+	}
+	else
+		*len = 0;
+	if(filename)
+		kfree(filename);
+	if(!error)
+		filp->f_pos = pos + *len;
+	return (error ? : 0);
+}
+#endif /* CONFIG_MOSIX_DFSA */
+
+void
+mosix_proc_init(void)
+{
+	struct proc_dir_entry *parent;
+
+	proc_register(proc_mosix, &proc_mosix_remote);
+
+	proc_register(proc_mosix, &proc_mosix_nodes);
+
+	parent = proc_mkdir("hpc/info", NULL);
+	proc_mosix_register(parent, info_ctl);
+
+	parent = proc_mkdir("hpc/decay", NULL);
+	proc_mosix_register(parent, decay_ctl);
+
+	parent = proc_mkdir("hpc/admin", NULL);
+	proc_mosix_register(parent, admin_ctl);
+}
+
+static void
+proc_mosix_register(struct proc_dir_entry *root, ctl_mosix *table)
+{
+	int mode;
+	struct proc_dir_entry *de;
+
+	for ( ; table->procname ; table++)
+	{
+		mode = table->mode | S_IFREG;
+		de = create_proc_entry(table->procname, mode, root);
+		if (!de) {
+			printk("proc_openmosix_register: create_proc_entry"
+				" failed for %s!\n", table->procname);
+			mosix_panic("proc_openmosix_register: null de");
+			continue;
+		}
+		de->data = (void *) table;
+		de->proc_iops = table->alt_iops ? : NULL;
+		de->proc_fops = table->alt_fops ? : &proc_mosix_file_operations;
+	}
+}
+
+static ssize_t
+do_rw_mosix(int write, struct file *file, char *buf, size_t count, loff_t *ppos)
+{
+	struct proc_dir_entry *de;
+	struct ctl_mosix *ctl;
+	ssize_t res;
+	ssize_t error;
+
+
+	de = (struct proc_dir_entry *) file->f_dentry->d_inode->u.generic_ip;
+	if (!de || !de->data)
+		return (-ENOTDIR);
+	ctl = (struct ctl_mosix *) de->data;
+	if (!ctl || !ctl->handler)
+		return (-ENOTDIR);
+
+	
+	res = count;
+	if((error = (*ctl->handler) (ctl, write, file, buf, &res)))
+		res = error;
+	return (res);
+}
+
+static inline ssize_t
+proc_readmosix(struct file *file, char *buf, size_t count, loff_t *ppos)
+{
+	return (do_rw_mosix(0, file, buf, count, ppos));
+}
+
+static inline ssize_t
+proc_writemosix(struct file *file, const char *buf, size_t count, loff_t *ppos)
+{
+	return(do_rw_mosix(1, file, (char *) buf, count, ppos));
+}
+
+#define TMPBUFLEN 20
+
+static ssize_t
+do_intarr(ctl_mosix *ctl, int write, struct file *filp,
+	  void *buffer, size_t *lenp, int scale)
+{
+	int *datap, vleft, first=1, len, left, neg, val;
+	int *min = NULL, *max = NULL;
+	char buf[TMPBUFLEN], *p;
+
+
+	if (!ctl->data || !ctl->maxlen || !*lenp ||
+	    (filp->f_pos && !write)) {
+		*lenp = 0;
+		return 0;
+	}
+	
+
+	datap = (int *) ctl->data;
+	if (write & CTLF_BOOLEAN) {
+		min = &zero;
+		max = &one;
+	} else if(write & CTLF_POSITIVE) {
+		min = &one;
+		max = &uintmax;
+	} else if (write & CTLF_UNSIGNED) {
+		min = &zero;
+		max = &uintmax;
+	} else if (write & CTLF_MINMAXP) {
+		min = ((int *) ctl->extra[0]) - 1;
+		max = ((int *) ctl->extra[1]) - 1;
+	} else if (write & CTLF_MINMAXV) {
+		min = (int *) &(ctl->extra[0]);
+		max = (int *) &(ctl->extra[1]);
+	}
+		
+	vleft = ctl->maxlen / sizeof(int);
+	left = *lenp;
+	
+	for (; left && vleft--; datap++, first=0) {
+
+
+		if (write) {
+			
+			int nex = TMPBUFLEN;
+			while (left) {
+				char c;
+				if(nex == TMPBUFLEN)
+				{
+					len = left;
+					if(len > TMPBUFLEN)
+						len = TMPBUFLEN;
+					if(copy_from_user(buf, buffer, len))
+						return(-EFAULT);
+					nex = 0;
+				}
+				c = buf[nex++];
+				if (!isspace(c))
+					break;
+				left--;
+				((char *) buffer)++;
+			}
+			if (!left)
+				break;
+			neg = 0;
+			len = left;
+			if (len > TMPBUFLEN-1)
+				len = TMPBUFLEN-1;
+			if(copy_from_user(buf, buffer, len))
+				return -EFAULT;
+			buf[len] = 0;
+			p = buf;
+			if (*p == '-' && left > 1) {
+				neg = 1;
+				left--, p++;
+			}
+			if (*p < '0' || *p > '9')
+				break;
+			val = simple_strtoul(p, &p, 0) * scale;
+			len = p-buf;
+			if ((len < left) && *p && !isspace(*p))
+				break;
+			if (neg)
+				val = -val;
+			buffer += len;
+			left -= len;
+
+			if (write & CTLF_MINMAXP) {
+				min++;
+				max++;
+			}
+
+
+			if (min && val < *min)
+				continue;
+			if (max && val > *max)
+				continue;
+
+
+			*datap = val;
+		} else {
+			p = buf;
+			if (!first)
+				*p++ = '\t';
+			sprintf(p, "%d", (*datap) / scale);
+			len = strlen(buf);
+			if (len > left)
+				len = left;
+			if(copy_to_user(buffer, buf, len))
+				return -EFAULT;
+			left -= len;
+			buffer += len;
+		}
+	}
+
+	if (!write && !first && left) {
+		if(put_user('\n', (char *) buffer))
+			return -EFAULT;
+		left--, buffer++;
+	}
+
+	if (write) {
+		int nex = TMPBUFLEN;
+
+		p = (char *) buffer;
+		while (left) {
+			char c;
+
+			if(nex == TMPBUFLEN)
+			{
+				len = left;
+				if(len > TMPBUFLEN)
+					len = TMPBUFLEN;
+				if(copy_from_user(buf, p, len))
+					return(-EFAULT);
+				nex = 0;
+			}
+			c = buf[nex++];
+			p++;
+			if (!isspace(c))
+				break;
+			left--;
+		}
+	}
+	if (write && first)
+		return -EINVAL;
+	*lenp -= left;
+	filp->f_pos += *lenp;
+	return 0;
+}
+
+static inline ssize_t
+get_intarr(struct file *file,const char *buf,size_t count,struct ctl_mosix *ctl)
+{
+	ssize_t res;
+	ssize_t error;
+
+	res = count;
+	error = (*ctl->handler) (ctl, 1, file, (char *)buf, &res);
+
+	if (error)
+		return (error);
+	return (res);
+}
+
+static inline ssize_t
+put_intarr(struct file *file,const char *buf,size_t count,struct ctl_mosix *ctl)
+{
+	ssize_t res;
+	ssize_t error;
+
+	res = count;
+	error = (*ctl->handler) (ctl, 0, file, (char *)buf, &res);
+
+	if (error)
+		return (error);
+	return (res);
+}
+
+static inline ssize_t
+ctl_boolean(ctl_mosix *ctl,int write,struct file *filp,void *buf,size_t *len)
+{
+	return (do_intarr(ctl, write ? CTLF_BOOLEAN : 0, filp, buf, len, 1));
+}
+
+static inline ssize_t
+ctl_uintarr(ctl_mosix *ctl,int write,struct file *filp,void *buf,size_t *len)
+{
+	return (do_intarr(ctl, write ? CTLF_UNSIGNED : 0, filp, buf, len, 1));
+}
+
+static inline ssize_t
+ctl_positive(ctl_mosix *ctl,int write,struct file *filp,void *buf,size_t *len)
+{
+	return (do_intarr(ctl, write ? CTLF_POSITIVE : 0, filp, buf, len, 1));
+}
+
+static inline ssize_t
+ctl_minmaxv(ctl_mosix *ctl,int write,struct file *filp,void *buf,size_t *len)
+{
+	return (do_intarr(ctl, write ? CTLF_MINMAXV : 0, filp, buf, len, 1));
+}
+
+static ssize_t
+ctl_admin_gateways(ctl_mosix *ctl, int write, struct file *filp,
+		   void *buf, size_t *len)
+{
+	int val = mosadmin_gateways;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(int), 0, ctl_minmaxv};
+
+	tmpctl.data = &val;
+	tmpctl.extra[0] = (void *)0;
+	tmpctl.extra[1] = (void *)2;
+
+	if (write)
+		error = get_intarr(filp, buf, *len, &tmpctl);
+	else
+		error = put_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+		return (error);
+	*len = error;
+	if(write)
+	{
+		lock_mosix();
+		mosadmin_gateways = val;
+		mosinfo_update_gateways();
+		unlock_mosix();
+	}
+	return (0);
+}
+
+static ssize_t
+ctl_admin_mospe(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	int this, tent;
+
+	if (!*len || (filp->f_pos && !write)) {
+		*len = 0;
+		return 0;
+	}
+	if (write) {
+		int pe, error;
+		struct ctl_mosix tmpctl =
+			{ 0, "goto", NULL, sizeof(int), 0, ctl_minmaxv };
+
+		tmpctl.data = &pe;
+		tmpctl.extra[0] = (void *) 0;
+		tmpctl.extra[1] = (void *) MOSIX_MAX;
+
+		error = get_intarr(filp, buf, *len, &tmpctl);
+		if (error < 0)
+			return (error);
+		if(pe < 0)
+			return(-ENOSYS);
+		return (mosix_config_set_pe(pe));
+	} else {
+		int n;
+		char tmpbuf[20];
+
+		if (filp->f_pos)
+			return (0);
+		this = mosix_config_get_pe();
+		tent = mosix_config_get_tentative_pe();
+		if (this == tent)
+			sprintf(tmpbuf, "%d\n", this);
+		else
+			sprintf(tmpbuf, "%d (%d)\n", this, tent);
+		n = strlen(tmpbuf);
+		if(n > *len)
+			n = *len;
+		if (copy_to_user(buf, tmpbuf, n))
+			return(-EFAULT);
+		*len = n;
+		filp->f_pos += n;
+		return (0);
+	}
+}
+
+#ifdef CONFIG_MOSIX_FS
+static ssize_t
+ctl_admin_mfscosts(ctl_mosix *ctl, int write, struct file *filp,
+			void *buf, size_t *len)
+{
+	ssize_t result = ctl_uintarr(ctl, write, filp, buf, len);
+
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	if(write)
+		info_update_mfscosts();
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	return(result);
+}
+
+static ssize_t
+ctl_admin_mfskill(ctl_mosix *ctl, int write, struct file *filp,
+	       void *buf, size_t *len)
+{
+	ssize_t error = 0;
+	int l;
+	char *filename;
+
+	if(!write)
+		return(-EPERM);
+	if(filp->f_pos)
+		return(0);
+	filename = getname(buf);
+	if(IS_ERR(filename))
+		return((int)filename);
+	l = strlen(filename);
+	if(l > *len)
+	{
+		filename[*len] = '\0';
+		l = *len;
+	}
+	if(l && filename[l-1] == '\n')
+		filename[--l] = '\0';
+	if(strchr(filename, '\n') || l >= *len)
+		error = -EINVAL;
+	else
+		error = mfs_kill(filename);
+	putname(filename);
+	if(!error)
+		filp->f_pos += *len;
+	return (error ? : 0);
+}
+#endif /* CONFIG_MOSIX_FS */
+
+static ssize_t
+ctl_admin_version(ctl_mosix *ctl, int write, struct file *filp,
+		  void *buf, size_t *len)
+{
+	int n, left;
+	char tmpbuf[100];
+
+	if ((filp->f_pos) || !*len) {
+		*len = 0;
+		return (0);
+	}
+
+	left = *len;
+	*len = 0;
+
+	sprintf(tmpbuf, "openMosix Version %d.%d.%d\nDFSA is %sabled\n"
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		"Maximum network topology = %d\n"
+#else
+		"Simple network topology\n"
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		, MOSIX_VERSION_PARTS(MOSIX_KERNEL_VERSION),
+#ifdef CONFIG_MOSIX_DFSA
+		"en"
+#else
+		"dis"
+#endif /* CONFIG_MOSIX_DFSA */
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		, MAX_MOSIX_TOPOLOGY
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+		);
+	n = strlen(tmpbuf);
+	if(n > left)
+		n = left;
+	if (copy_to_user(buf, tmpbuf, n))
+		return (-EFAULT);
+	*len += n;
+	filp->f_pos += *len;
+	return (0);
+}
+
+static ssize_t
+ctl_admin_config(ctl_mosix *ctl, int write, struct file *filp,
+		 void *buf, size_t *len)
+{
+	struct mosixnet *mos;
+	int copy = *len;
+	int pos = copy / sizeof(struct mosixnet);
+	int fpos = filp->f_pos / sizeof(struct mosixnet);
+	int error = 0;
+
+	/* position in this file is entry # in the config */
+
+
+	/* truncate read/write to multiples of sizeof(strcut mosixnet) */
+	if (*len % sizeof(struct mosixnet))
+		*len -= *len % sizeof(struct mosixnet);
+
+	if ((write && filp->f_pos) || !*len) {
+		*len = 0;
+		return (0);
+	}
+
+
+	if (write) {
+		pos = copy / sizeof(struct mosixnet);
+		if(pos <= 0)
+		{
+			*len = 0;
+			return(0);
+		}
+		if (!(mos = (struct mosixnet *) kmalloc(copy, GFP_USER)))
+			return (-ENOMEM);
+		if (copy_from_user((char *) mos, buf, copy))
+		{
+			kfree(mos);
+			return (-EFAULT);
+		}
+		error = mosix_config_set_table(mos, pos,
+					mosix_config_get_tentative_pe());
+		if (error)
+			kfree((void *) mos);
+	} else {
+		pos = mosix_config_get_table(&mos, fpos, pos);
+		if (pos < 0)
+			return (pos);
+		copy = pos * sizeof(struct mosixnet);
+		if (copy)
+		{
+			if(copy_to_user(buf, (char *) mos, copy))
+				error = -EFAULT;
+			kfree((void *) mos);
+		}
+	}
+
+	if (error < 0)
+		return (error);
+	*len = copy;
+	filp->f_pos += copy;
+	return (0);
+}
+
+static ssize_t
+ctl_admin_expel(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	int val = 0;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(int), 0, ctl_boolean};
+
+	if (!write)
+		return (-EPERM);
+	
+	tmpctl.data = &val;
+	error = get_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+		return (error);
+	*len = error;
+	return (val ? expel(0) : 0);
+}
+
+static ssize_t
+ctl_admin_bring(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	int val = 0;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(int), 0, ctl_boolean};
+
+	if (!write)
+		return (-EPERM);
+	
+	tmpctl.data = &val;
+	error = get_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+		return (error);
+	*len = error;
+	return (val ? bring() : 0);
+}
+
+static ssize_t
+ctl_admin_speed(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	int val = cpuspeed;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(int), 0, ctl_minmaxv};
+
+	tmpctl.data = &val;
+	tmpctl.extra[0] = (void *)1;
+	tmpctl.extra[1] = (void *)65535;
+
+	if (write)
+		error = get_intarr(filp, buf, *len, &tmpctl);
+	else
+		error = put_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+		return (error);
+	*len = error;
+	if(write)
+	{
+		lock_mosix();
+		cpuspeed = val;
+		set_my_cpuspeed();
+		unlock_mosix();
+	}
+	return (0);
+}
+#ifdef CONFIG_MOSIX_LOADLIMIT
+extern void set_loadlimit(void);
+extern void set_loadlimitmode(void);
+extern void set_cpulimit(void);
+extern void set_cpulimitmode(void);
+static ssize_t
+ctl_admin_loadlimit(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	unsigned long val = load_limit;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(unsigned long), 0, ctl_uintarr};
+
+	tmpctl.data = &val;
+	if (write)
+		error = get_intarr(filp, buf, *len, &tmpctl);
+	else
+		error = put_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+		return (error);
+	*len = error;
+	if(write)
+	{
+		lock_mosix();
+		load_limit = val;
+		set_loadlimit();
+		/*set_my_cpuspeed();*/
+		unlock_mosix();
+	}
+	return (0);
+}
+static ssize_t
+ctl_admin_llimitmode(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	unsigned long val = mosadmin_mode_loadlimit;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(unsigned long), 
+	  0, ctl_minmaxv};
+	tmpctl.extra[0] = (void *)0;
+	tmpctl.extra[1] = (void *)2;
+	tmpctl.data = &val;
+	if (write)
+  	  error = get_intarr(filp, buf, *len, &tmpctl);
+	else
+	  error = put_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+	  return (error);
+	*len = error;
+	if(write)
+  	  {
+	    lock_mosix();
+	    mosadmin_mode_loadlimit = val;
+	    set_loadlimitmode();
+	    unlock_mosix();
+  	  }
+	return (0);
+}
+static ssize_t
+ctl_admin_cpulimit(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	unsigned long val = cpu_limit;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(unsigned long), 0, ctl_uintarr};
+
+	tmpctl.data = &val;
+	if (write)
+		error = get_intarr(filp, buf, *len, &tmpctl);
+	else
+		error = put_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+		return (error);
+	*len = error;
+	if(write)
+	{
+		lock_mosix();
+		cpu_limit = val;
+		set_cpulimit();
+		unlock_mosix();
+	}
+	return (0);
+}
+static ssize_t
+ctl_admin_cpulimitmode(ctl_mosix *ctl, int write, struct file *filp,
+		void *buf, size_t *len)
+{
+	unsigned long val = mosadmin_mode_loadlimit;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(unsigned long), 
+	  0, ctl_minmaxv};
+	tmpctl.extra[0] = (void *)0;
+	tmpctl.extra[1] = (void *)2;
+	tmpctl.data = &val;
+	if (write)
+  	  error = get_intarr(filp, buf, *len, &tmpctl);
+	else
+	  error = put_intarr(filp, buf, *len, &tmpctl);
+	if (error < 0)
+	  return (error);
+	*len = error;
+	if(write)
+  	  {
+	    lock_mosix();
+	    mosadmin_mode_cpulimit = val;
+	    set_cpulimitmode();
+	    unlock_mosix();
+  	  }
+	return (0);
+}
+#endif
+
+static ssize_t
+ctl_admin_mode(ctl_mosix *ctl, int write, struct file *filp,
+	       void *buf, size_t *len)
+{
+	int val, mode;
+	int error;
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(int), 0, ctl_boolean};
+
+	tmpctl.data = &val;
+
+	switch (ctl->ctl_name) {
+	case ADMIN_STAY:
+		mode = DS_STAY;
+		break;
+	case ADMIN_LSTAY:
+		mode = DS_LSTAY;
+		break;
+	case ADMIN_BLOCK:
+		mode = DS_BLOCK;
+		break;
+	case ADMIN_QUIET:
+		mode = DS_QUIET;
+		break;
+	case ADMIN_NOMFS:
+		mode = DS_NOMFS;
+		break;
+	default:
+		panic("ctl_admin_mode: invalid ctl_name");
+	}
+
+	if (write) {
+		error = get_intarr(filp, buf, *len, &tmpctl);
+		if (error < 0)
+			return (error);
+		*len = error;
+		return (admin_set_mode(mode, val));
+	} else {
+		val = admin_get_mode(mode);
+		error = put_intarr(filp, buf, *len, &tmpctl);
+		if (error < 0)
+			return (error);
+		*len = error;
+		return (0);
+	}
+}
+
+static ssize_t
+ctl_admin_slowdecay(ctl_mosix *ctl, int write, struct file *filp,
+		    void *buf, size_t *len)
+{
+	ctl->data = (void *) &slow_alpha;
+	ctl->extra[0] = (void *) fast_alpha;
+	ctl->extra[1] = (void *) DECAY_QUOTIENT;
+	return (do_intarr(ctl, write ? CTLF_MINMAXV : 0, filp, buf, len, 1));
+}
+
+static ssize_t
+ctl_admin_fastdecay(ctl_mosix *ctl, int write, struct file *filp,
+		    void *buf, size_t *len)
+{
+	ctl->data = (void *) &fast_alpha;
+	ctl->extra[0] = (void *) 0;
+	ctl->extra[1] = (void *) slow_alpha;
+	return (do_intarr(ctl, write ? CTLF_MINMAXV : 0, filp, buf, len, 1));
+}
+
+static ssize_t
+ctl_admin_decayinterval(ctl_mosix *ctl, int write, struct file *filp,
+		        void *buf, size_t *len)
+{
+	ctl->data = (void *) &decay_interval;
+	ctl->extra[0] = (void *) 1;
+	ctl->extra[1] = (void *) 65535;
+	return (do_intarr(ctl, write ? CTLF_MINMAXV : 0, filp, buf, len, 1));
+}
+
+void
+proc_update_costs(void)
+{
+	register int i;
+	register struct task_struct *p;
+
+	lock_mosix();
+	for(i = 0 ; i < MAX_MOSIX_TOPOLOGY ; i++)
+	{
+		deputy_here[i].page = mosix_cost[i].PAGE_D;
+		deputy_here[i].syscall = mosix_cost[i].SYSCALL_D;
+		deputy_here[i].out = mosix_cost[i].COPYOUT_BASE_D;
+		deputy_here[i].outkb = mosix_cost[i].COPYOUT_PER_KB_D;
+		deputy_here[i].in = mosix_cost[i].COPYIN_BASE_D;
+		deputy_here[i].inkb = mosix_cost[i].COPYIN_PER_KB_D;
+#ifdef CONFIG_MOSIX_TOPOLOGY
+		deputy_here[i].first = mosix_cost[i].first;
+		deputy_here[i].last = mosix_cost[i].last;
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+	}
+	info_update_costs();
+	read_lock(&tasklist_lock);
+	for_each_task(p)
+	if(p->mosix.dflags & DDEPUTY)
+	{
+		tell_process(p, DREQ_UPDOVERHEADS);
+		wake_up_mosix(p);
+	}
+	read_unlock(&tasklist_lock);
+	unlock_mosix();
+}
+
+static ssize_t
+ctl_admin_overheads(ctl_mosix *ctl, int write, struct file *filp,
+			void *buf, size_t *len)
+{
+	ssize_t result = ctl_uintarr(ctl, write, filp, buf, len);
+
+	if(write)
+		proc_update_costs();
+	return(result);
+}
+
+static loff_t
+proc_lseekmosixinfo(struct file *filp, loff_t offset, int orig)
+{
+	switch (orig) {
+		case 0:
+			break;
+		case 1:
+			offset += filp->f_pos;
+			break;
+		case 2:
+			offset += mosix_config_get_limit();
+			break;
+		default:
+			return (-EINVAL);
+        }
+	if(offset < 0 || offset > MOSIX_MAX)
+		return(-EINVAL);
+	filp->f_pos = offset;
+	return (offset);
+}
+
+static ssize_t
+ctl_info_infos(ctl_mosix *ctl, int write, struct file *filp,
+	       void *buf, size_t *len)
+{
+	int end;
+	int n, err;
+
+	end = (*len / sizeof(struct mosix_info)) + filp->f_pos;
+	if(end > (n = mosix_config_get_limit()))
+		end = n;
+	*len = 0;
+	if((n = end - filp->f_pos) > 0)
+	{
+		if((err = balance_get_infos(filp->f_pos + 1, n,
+						(struct mosix_info *)buf, 1)))
+			return(err);
+		filp->f_pos += n;
+		*len = n * sizeof(struct mosix_info);
+	}
+
+	return (0);
+}
+
+#define	get_item(x, node, undef, notup) ( { \
+		struct mosix_info info; \
+		(void) balance_get_info(node, &info); \
+		(info.status & DS_MOSIX_UP) ? info.x : \
+		(info.status & DS_MOSIX_DEF) ? notup : undef; } )
+
+static ssize_t
+ctl_info_fill(ctl_mosix *ctl, int write, struct file *filp,
+	      void *buf, size_t *len)
+{
+	int i, end;
+	int total = 0;
+	s64 val;
+
+	end = (*len / sizeof(u64)) + filp->f_pos;
+	if(end > (i = mosix_config_get_limit()))
+		end = i;
+	for (i = filp->f_pos + 1; i <= end; i++) {
+		switch (ctl->ctl_name) {
+		case INFO_LOADS:
+			val = get_item(load, i, -ENXIO, -ENETUNREACH);
+			break;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+		case INFO_LOADLIMIT:
+			val = get_item(load_limit, i, -ENXIO, -ENETUNREACH);
+ 			break;
+		case INFO_LLIMITMODE:
+			val = get_item(llimitmode, i, -ENXIO, -ENETUNREACH);
+ 			break;
+		case INFO_LOADREMOTE:
+			val = get_item(loadremote, i, -ENXIO, -ENETUNREACH);
+ 			break;
+		case INFO_LOADLOCAL:
+			val = get_item(loadlocal, i, -ENXIO, -ENETUNREACH);
+ 			break;
+		case INFO_CPULIMIT:
+			val = get_item(cpu_limit, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_CPULIMITMODE:
+			val = get_item(cpulimitmode, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_CPUREMOTE:
+			val = get_item(cpuremote, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_CPULOCAL:
+			val = get_item(cpulocal, i, -ENXIO, -ENETUNREACH);
+			break;
+#endif
+		case INFO_SPEEDS:
+			val = get_item(speed, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_CPUS:
+			val = get_item(ncpus, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_MEMS:
+			val = get_item(mem, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_RMEMS:
+			val = get_item(rmem, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_TMEMS:
+			val = get_item(tmem, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_UTILS:
+			val = get_item(util, i, -ENXIO, -ENETUNREACH);
+			break;
+		case INFO_STATA:
+			val = get_item(status, i, 0, DS_MOSIX_DEF);
+			break;
+		default:
+			mosix_panic("ctl_info_fill - bad name");
+			return (-EDIST);
+		}
+		if (copy_to_user(buf, (char *) &val, sizeof(u64)))
+			return (-EFAULT);
+		filp->f_pos++;
+		buf += sizeof(u64);
+		total += sizeof(u64);
+	}
+	*len = total;
+	return (0);
+}
+
+static ssize_t
+ctl_decay(ctl_mosix *ctl, int write, struct file *filp, void *buf, size_t *len)
+{
+	int val, policy;
+	int error;
+	int (*func)(int);
+	int decay[2];
+	struct ctl_mosix tmpctl = {0, NULL, NULL, sizeof(int), 0, ctl_boolean};
+
+	tmpctl.data = &val;
+
+	switch (ctl->ctl_name) {
+	case DECAY_INHERIT:
+		func = decay_inherit;
+		goto r01w01;
+	case DECAY_EXEC:
+		func = decay_exec;
+		goto r01w01;
+	case DECAY_EXECONCE:
+		func = decay_execonce;
+	r01w01:
+		if (write) {
+			error = get_intarr(filp, buf, *len, &tmpctl);
+			if (error < 0)
+				return (error);
+			(*func)(val);
+		} else {
+			val = (*func)(-1);
+			error = put_intarr(filp, buf, *len, &tmpctl);
+			if (error < 0)
+				return (error);
+		}
+		break;
+
+	case DECAY_CPUJOB:
+		policy = DADV_CPU;
+		goto r01w1;
+	case DECAY_IOJOB:
+		policy = DADV_NOCPU;
+		goto r01w1;
+	case DECAY_SLOW:
+		policy = DADV_SLOWDECAY;
+		goto r01w1;
+	case DECAY_FAST:
+		policy = DADV_FASTDECAY;
+	r01w1:
+		if (write) {
+			error = get_intarr(filp, buf, *len, &tmpctl);
+			if (error < 0)
+				return (error);
+			if (val != 1)
+				return (-EINVAL);
+			decay_set(policy, 0, 1);
+		} else {
+			val = decay_get(policy);
+			error = put_intarr(filp, buf, *len, &tmpctl);
+			if (error < 0)
+				return (error);
+		}
+		break;
+
+	case DECAY_OWN:
+		tmpctl.data = (void *) decay;
+		tmpctl.maxlen = 2 * sizeof(int);
+		tmpctl.handler = ctl_uintarr;
+
+		/* to force an error in case of partial data */
+		decay[0] = decay[1] = 0;
+
+		if (write) {
+			error = get_intarr(filp, buf, *len, &tmpctl);
+			if (error < 0)
+				return (error);
+			if (decay[0] < 0 || decay[0] > DECAY_QUOTIENT
+			    || decay[1] < 1 || decay[1] > 65535)
+				return (-EINVAL);
+			decay_set(DADV_OWNDECAY, decay[0], decay[1]);
+		} else {
+			if (decay_get(DADV_OWNDECAY)) {
+				decay[0] = current->mosix.decay;
+				decay[1] = current->mosix.deccycle;
+			} else
+				tmpctl.maxlen = sizeof(int);
+			error = put_intarr(filp, buf, *len, &tmpctl);
+			if (error < 0)
+				return (error);
+		}
+		break;
+
+	case DECAY_CLEAR:
+		if (!write)
+			return (-EPERM);
+		error = get_intarr(filp, buf, *len, &tmpctl);
+		if (error < 0)
+			return (error);
+		if (val != 1)
+			return (-EINVAL);
+		decay_clear();
+		break;
+	default:
+		return (-EBADF);
+	}
+	*len = error;
+	return (0);
+}
+
+
+#define for_each_remote_task(p) \
+        for (p = &init_task ; (p = p->next_task) != &init_task ; ) \
+	        if(p->mosix.dflags & DREMOTE)
+
+
+#define NUMBUF	10
+
+static int
+proc_mosix_remote_readdir(struct file *filp, void *dirent, filldir_t filldir)
+{
+	struct task_struct *p;
+	char buf[NUMBUF];
+	unsigned int nr = filp->f_pos;
+	pid_t *pids;
+	int k, n = 0;
+
+	if(filp->f_pos == 0)
+	{
+		if(filldir(dirent, ".", 1, 0, filp->f_dentry->d_inode->i_ino,
+								DT_DIR) < 0)
+			return(0);
+		filp->f_pos = 1;
+	}
+	if(filp->f_pos == 1)
+	{
+		if(filldir(dirent, "..", 2, 1,
+			filp->f_dentry->d_parent->d_inode->i_ino, DT_DIR) < 0)
+			return(0);
+		filp->f_pos = 2;
+	}
+
+	n = 1;
+	while(1)
+	{
+		k = count_guests(); /* usually correct, but not 100% reliable */
+		if(k > n)
+			n = k;
+		if(!(pids = (pid_t *)kmalloc(n * sizeof(pid_t), GFP_KERNEL)))
+			return(-ENOMEM);
+		read_lock(&tasklist_lock);
+		/* new guest(s) could come in while we waited for memory! */
+		k = 0;
+		for_each_remote_task(p)
+		{
+			if(k < n)
+				pids[k++] = p->pid;
+			else
+				k++;
+		}
+		read_unlock(&tasklist_lock);
+		if(k <= n)
+		{
+			n = k;
+			break;
+		}
+		n = k + 1;
+	}
+	nr = 2;
+	for(k = 0 ; k < n ; k++) {
+		unsigned int pid;
+		unsigned long i, j;
+
+		if(nr++ < filp->f_pos)
+			continue;
+		pid = pids[k];
+
+		for (j = NUMBUF, i = pid; i; i /= 10) {
+			j--;
+			buf[j] = '0' + (i % 10);
+		}
+		if (filldir(dirent, buf+j, NUMBUF-j, filp->f_pos,
+				(pid << 16) + PROC_REMPID_INO, DT_DIR) < 0)
+			break;
+		filp->f_pos++;
+	}
+	kfree(pids);
+	return(0);
+}
+
+static int
+proc_mosix_sub_readdir(struct file *filp, void *dirent, filldir_t filldir)
+{
+	struct dentry *dp = filp->f_dentry;
+	int id = dp->d_inode->i_ino & ~0xffff;
+	struct subnames *s;
+	int i;
+
+	switch(dp->d_inode->i_ino & 0xffff)
+	{
+	case PROC_REMPID_INO:
+		s = rempid_subs;
+		break;
+	case PROC_NODEID_INO:
+		s = nodeid_subs;
+		break;
+	default:
+		printk("ino=0x%lx\n", dp->d_inode->i_ino);
+		panic("proc_mosix_sub_readdir");
+	}
+	if(filp->f_pos == 0)
+	{
+		if(filldir(dirent, ".", 1, 0, dp->d_inode->i_ino, DT_DIR) < 0)
+			return(0);
+		filp->f_pos = 1;
+	}
+	if(filp->f_pos == 1)
+	{
+		if(filldir(dirent, "..", 2, 1, dp->d_parent->d_inode->i_ino,
+								DT_DIR) < 0)
+			return(0);
+		filp->f_pos = 2;
+	}
+	for(i = 2 ; i < filp->f_pos ; i++)
+	if(s->name)
+		s++;
+	else
+		return(0);
+	while(s->name && filldir(dirent, s->name, strlen(s->name), filp->f_pos,
+						id | s->id, DT_REG) >= 0)
+	{
+		filp->f_pos++;
+		s++;
+	}
+	return(0);
+}
+
+static struct dentry *
+proc_mosix_sub_lookup(struct inode *dir, struct dentry *dentry)
+{
+	unsigned long dino = dir->i_ino;
+	struct subnames *s;
+	const char *name = dentry->d_name.name;
+	int len = dentry->d_name.len;
+	struct inode *inode = NULL;
+
+	switch(dino & 0xffff)
+	{
+	case PROC_REMPID_INO:
+		s = rempid_subs;
+		break;
+	case PROC_NODEID_INO:
+		s = nodeid_subs;
+		break;
+	default:
+		printk("ino=0x%lx\n", dino);
+		panic("proc_mosix_sub_lookup");
+	}
+	while(s->name)
+		if(s->namelen == len && !strncmp(s->name, name, len))
+		{
+			inode = proc_get_inode(dir->i_sb, (dino & ~0xffff)|s->id, NULL);
+			if(!inode)
+				return(ERR_PTR(-EINVAL));
+			switch(s->id)
+			{
+			case PROC_REMPID_GOTO:
+				inode->i_mode = S_IFREG | 0222;
+				break;
+			default:
+				inode->i_mode = S_IFREG | 0444;
+				break;
+			}
+			inode->i_op = &proc_mosix_sub_inode_operations;
+			inode->i_fop = &proc_mosix_sub_file_operations;
+			break;
+		}
+		else
+			s++;
+	dentry->d_op = &proc_mosix_dynamic_dentry_operations;
+	d_add(dentry, inode);
+	return(NULL);
+}
+
+int
+atoi16(const char *num, int len)
+{
+	int n = 0;
+	char c;
+
+	while(len-- > 0)
+	{
+		c = *num++;
+		if(c < '0' || c > '9')
+			return(0);
+		n = n * 10 + c - '0';
+		if(n & 0xffff0000)
+			return(0);
+	}
+	return(n);
+}
+
+static struct dentry *
+proc_mosix_remote_lookup(struct inode *dir, struct dentry *dentry)
+{
+	unsigned int pid, n;
+	struct task_struct *p;
+	struct inode *inode = NULL;
+
+	n = proc_mosix_remote.nlink;
+	read_lock(&tasklist_lock);
+	for_each_remote_task(p)
+		n++;
+	read_unlock(&tasklist_lock);
+	dir->i_nlink = n;
+
+	pid = atoi16(dentry->d_name.name, dentry->d_name.len);
+	if(!pid)
+		goto out;
+
+	read_lock(&tasklist_lock);
+	p = find_any_task_by_pid(pid);
+	if (p && !(p->mosix.dflags & DREMOTE))
+		p = NULL;
+	read_unlock(&tasklist_lock);
+
+	inode = NULL;
+	if (pid && p) {
+		inode = proc_get_inode(dir->i_sb,
+			(pid << 16) | PROC_REMPID_INO, NULL);
+		if (!inode)
+			return ERR_PTR(-EINVAL);
+		inode->i_mode = S_IFDIR | 0555;
+		inode->i_op = &proc_mosix_subdir_inode_operations;
+		inode->i_fop = &proc_mosix_subdir_file_operations;
+	}
+
+	out:
+	dentry->d_op = &proc_mosix_dynamic_dentry_operations;
+	d_add(dentry, inode);
+	return(NULL);
+}
+
+static int
+proc_mosix_nodes_readdir(struct file *filp, void *dirent, filldir_t filldir)
+{
+	struct mosixnet *mos;
+	char buf[NUMBUF];
+	unsigned int nr = filp->f_pos;
+	int nmos, k, l, node;
+
+	if(filp->f_pos == 0)
+	{
+		if(filldir(dirent, ".", 1, 0, filp->f_dentry->d_inode->i_ino,
+								DT_DIR) < 0)
+			return(0);
+		filp->f_pos = 1;
+	}
+	if(filp->f_pos == 1)
+	{
+		if(filldir(dirent, "..", 2, 1,
+				filp->f_dentry->d_parent->d_inode->i_ino,
+								DT_DIR) < 0)
+			return(0);
+		filp->f_pos = 2;
+	}
+
+	if((nmos = mosix_config_get_table(&mos, 0, 0)) <= 0)
+		return (nmos);
+	
+	nr = 2;
+	for(k = 0 ; k < nmos ; k++)
+		for (l = 0; l < mos[k].cnt; l++) {
+			unsigned long i, j;
+
+			if(nr++ < filp->f_pos)
+				continue;
+
+			node = mos[k].base + l;
+			for (j = NUMBUF, i = node; i; i /= 10) {
+				j--;
+				buf[j] = '0' + (i % 10);
+			}
+			if (filldir(dirent, buf+j, NUMBUF-j, filp->f_pos,
+				(node << 16)+PROC_NODEID_INO, DT_REG) < 0)
+				goto out;
+			filp->f_pos++;
+		}
+out:
+	if(nmos)
+		kfree(mos);
+	return (0);
+}
+
+static struct dentry *
+proc_mosix_nodes_lookup(struct inode *dir, struct dentry *dentry)
+{
+	unsigned int node;
+	struct inode *inode = NULL;
+
+	dir->i_nlink = proc_mosix_nodes.nlink + count_mosix_nodes();
+
+	node = atoi16(dentry->d_name.name, dentry->d_name.len);
+
+	if(!mos_to_net(node, NULL))
+		node = 0;
+	if (node)
+	{
+		inode = proc_get_inode(dir->i_sb,
+			(node << 16) | PROC_NODEID_INO, NULL);
+		if (!inode)
+			return ERR_PTR(-EINVAL);
+		inode->i_mode = S_IFDIR | 0555;
+		inode->i_op = &proc_mosix_subdir_inode_operations;
+		inode->i_fop = &proc_mosix_subdir_file_operations;
+	}
+
+	dentry->d_op = &proc_mosix_dynamic_dentry_operations;
+	d_add(dentry, inode);
+	return(NULL);
+}
+
+ssize_t
+proc_mosix_sub_read(struct file *filp, char *buf, size_t count, loff_t *ppos)
+{
+	struct task_struct *r;
+	char *page;
+	unsigned long rino = filp->f_dentry->d_inode->i_ino;
+	unsigned long ino = rino & 0xffff;
+	int pid_or_node = rino >> 16;
+	int result;
+	int (*func)(struct task_struct *, char *);
+
+	if(!(page = (char *)__get_free_page(GFP_KERNEL)))
+		return(-ENOMEM);
+	switch(ino)
+	{
+	case PROC_REMPID_FROM:
+		func = proc_mosix_get_remote_from;
+		break;
+	case PROC_REMPID_STATM:
+		func = proc_pid_statm;
+		break;
+	case PROC_REMPID_STATS:
+		func = proc_mosix_get_remote_stats;
+		break;
+	case PROC_REMPID_IDENT:
+		func = proc_mosix_get_remote_identity;
+		break;
+	case PROC_NODEID_CPUS:
+		result = sprintf(page, "%d\n", (int)get_item(ncpus,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_LOAD:
+		result = sprintf(page, "%d\n", (int)get_item(load,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+#ifdef CONFIG_MOSIX_LOADLIMIT
+	case PROC_NODEID_LOADLIMIT:
+		result = sprintf(page, "%d\n", (int)get_item(load_limit,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_LLIMITMODE:
+		result = sprintf(page, "%d\n", (int)get_item(llimitmode,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_LOADLOCAL:
+		result = sprintf(page, "%d\n", (int)get_item(loadlocal,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_LOADREMOTE:
+		result = sprintf(page, "%d\n", (int)get_item(loadremote,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_CPULIMIT:
+		result = sprintf(page, "%d\n", (int)get_item(cpu_limit,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_CPULIMITMODE:
+		result = sprintf(page, "%d\n", (int)get_item(cpulimitmode,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_CPULOCAL:
+		result = sprintf(page, "%d\n", (int)get_item(cpulocal,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_CPUREMOTE:
+		result = sprintf(page, "%d\n", (int)get_item(cpuremote,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+#endif
+	case PROC_NODEID_MEM:
+		result = sprintf(page, "%lld\n",
+		    		(s64)get_item(mem, pid_or_node,
+					-ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_RMEM:
+		result = sprintf(page, "%lld\n",
+				(s64)get_item(rmem, pid_or_node,
+					-ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_SPEED:
+		result = sprintf(page, "%d\n", (int)get_item(speed,
+		      				pid_or_node,
+					-ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_TMEM:
+		result = sprintf(page, "%lld\n",
+			     	(s64) get_item(tmem, pid_or_node,
+					-ENXIO, -ENETUNREACH));
+		goto copy;
+	case PROC_NODEID_STATUS:
+		result = sprintf(page, "%d\n", (int)get_item(status,
+							     pid_or_node, 0, DS_MOSIX_DEF));
+		goto copy;
+	case PROC_NODEID_UTIL:
+		result = sprintf(page, "%d\n", (int)get_item(util,
+							     pid_or_node, -ENXIO, -ENETUNREACH));
+		goto copy;
+	default:
+		result = -EPERM;	/* write-only */
+		goto out;
+	}
+	result = -EBADF;
+	read_lock(&tasklist_lock);
+	r = find_any_task_by_pid(pid_or_node);
+	if(r && !(r->mosix.dflags & DREMOTE))
+		r = NULL;
+	if(r)
+		get_task_struct(r);
+	read_unlock(&tasklist_lock);
+	if(!r)
+		goto out;
+	result = (*func)(r, page);
+	free_task_struct(r);
+	copy:
+	if(result > 0)
+	{
+		if(*ppos + count > result)
+		{
+			count = result - *ppos;
+			if(count < 0)
+				count = 0;
+		}
+		if(count && copy_to_user(buf, page, count))
+			return(-EFAULT);
+		*ppos += count;
+		result = count;
+	}
+	out:
+	free_page((unsigned long)page);
+	return(result);
+}
+
+ssize_t
+proc_mosix_sub_write(struct file *filp, const char *buf, size_t count, loff_t *ppos)
+{
+	unsigned long rino = filp->f_dentry->d_inode->i_ino;
+	unsigned long ino = rino & 0xffff;
+	int pid_or_node = rino >> 16;
+			
+	switch(ino) {
+	case PROC_REMPID_GOTO:
+		return(proc_mosix_set_remote_goto(filp, pid_or_node,
+						  buf, count));
+	default:
+		return(-EPERM);		/* read-only */
+	}
+}
+
+ssize_t
+proc_mosix_pid_set_migrate(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int mig, error, len;
+	struct ctl_mosix tmpctl =
+		{ 0, "migrate", NULL, sizeof(int), 0, ctl_minmaxv };
+
+	if(task != current)
+		return(-EPERM);
+
+	tmpctl.data = &mig;
+	tmpctl.extra[0] = (void *) DM_BALANCE;
+	tmpctl.extra[1] = (void *) MOSIX_MAX;
+	error = get_intarr(filp, buf, cnt, &tmpctl);
+	if (error < 0)
+		return (error);
+	len = error;
+
+	if ((error = mig_migrate(mig)))
+		return (error);
+	else
+		return (len);
+}
+
+ssize_t
+proc_mosix_pid_set_goto(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int whereto, error;
+	struct ctl_mosix tmpctl =
+		{ 0, "goto", NULL, sizeof(int), 0, ctl_minmaxv };
+
+	/* the rule is: if you can send it a signal, you may also migrate it: */
+	/* so keep looking for changes in "kernel/signal.c" */
+
+	if ((current->euid ^ task->suid) && (current->euid ^ task->uid) &&
+		(current->uid ^ task->suid) && (current->uid ^ task->uid) &&
+		!capable(CAP_KILL))
+		return(-EPERM);
+
+	tmpctl.data = &whereto;
+	tmpctl.extra[0] = (void *) DM_BALANCE;
+	tmpctl.extra[1] = (void *) MOSIX_MAX;
+	error = get_intarr(filp, buf, cnt, &tmpctl);
+	if (error < 0)
+		return (error);
+	if(whereto > 0 && !mos_to_net(whereto, NULL))
+		return(-ENODEV);
+
+	if (whereto <= 0) {
+		switch (whereto) {
+		case DM_GOBACKHOME:
+			whereto = GOBACKHOME;
+			break;
+		case DM_BALANCE:
+			whereto = BALANCE;
+			break;
+
+		default:
+			return(-EINVAL);
+		}
+	}
+	if (task->mosix.stay & DSTAY)
+		return (-EROFS);
+	mosix_add_to_whereto(task, whereto);
+	return (error);
+}
+
+ssize_t
+proc_mosix_pid_set_lock(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int lock, len;
+	struct ctl_mosix ctl =
+		{ 0, "lock", NULL, sizeof(int), 0, ctl_boolean };
+
+	ctl.data = (void *)&lock;
+
+	if(task == current)
+	{
+		len = get_intarr(filp, buf, cnt, &ctl);
+		if (len < 0)
+			return (len);
+		mig_set_lock(lock);
+		return (len);
+	}
+	if(!suser())
+		return(-EPERM);
+	/* The SU has the special privillege of unlocking local processes */
+	len = get_intarr(filp, buf, cnt, &ctl);
+	if(len < 0)
+		return(len);
+	if(lock)
+		return(-EINVAL);
+	task_lock(task);
+	if (task->mosix.dflags & (DDEPUTY|DFINISHED))
+		len = -EACCES;
+	else
+		task->mosix.stay &= ~DNOMIGRATE;
+	task_unlock(task);
+	return(len);
+}
+
+ssize_t
+proc_mosix_pid_set_migfilter(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int migfilter, len;
+	struct ctl_mosix ctl =
+		{ 0, "migfilter", NULL, sizeof(int), 0, ctl_boolean };
+
+	ctl.data = (void *)&migfilter;
+
+	if(task == current)
+	{
+		len = get_intarr(filp, buf, cnt, &ctl);
+		if (len < 0)
+			return (len);
+		mig_set_migfilter(migfilter);
+		return (len);
+	}
+	if(!suser())
+		return(-EPERM);
+	len = get_intarr(filp, buf, cnt, &ctl);
+	if(len < 0)
+		return(len);
+	if(migfilter)
+		return(-EINVAL);
+	task_lock(task);
+	task->mosix.dflags &= ~DMIGFILTER;
+	task_unlock(task);
+	return(len);
+}
+
+ssize_t
+proc_mosix_pid_set_migpolicy(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int migpolicy, len;
+	struct ctl_mosix ctl = { 0, "migpolicy", NULL, sizeof(int), 0, ctl_positive };
+	ctl.data = (void *)&migpolicy;
+
+	if(task == current)
+	{
+		len = get_intarr(filp, buf, cnt, &ctl);
+		if (len < 0)
+			return (len);
+		mig_set_migpolicy(migpolicy);
+		return (len);
+	}
+	if(!suser())
+		return(-EPERM);
+	len = get_intarr(filp, buf, cnt, &ctl);
+	if(len < 0)
+		return(len);
+	task_lock(task);
+	task->mosix.mask.migpolicy = migpolicy;
+	task_unlock(task);
+	return(len);
+}
+
+ssize_t
+proc_mosix_pid_set_mignodes(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int mignodes, len;
+	struct ctl_mosix ctl =
+		{ 0, "mignodes", NULL, sizeof(int), 0, ctl_uintarr };
+
+	ctl.data = (void *)&mignodes;
+
+	if(task == current)
+	{
+		len = get_intarr(filp, buf, cnt, &ctl);
+		if (len < 0)
+			return (len);
+		mig_set_mignodes(mignodes);
+		return (len);
+	}
+	if(!suser())
+		return(-EPERM);
+	len = get_intarr(filp, buf, cnt, &ctl);
+	if(len < 0)
+		return(len);
+	task_lock(task);
+	task->mosix.mask.mignodes = mignodes;
+	task_unlock(task);
+	return(len);
+}
+
+ssize_t
+proc_mosix_pid_set_miggroup(struct file *filp, struct task_struct *task,
+                                                const char *buf, size_t cnt)
+{
+        int miggroup, len;
+        struct ctl_mosix ctl = { 0, "miggroup", NULL, sizeof(int), 0, ctl_positive };
+        ctl.data = (void *)&miggroup;
+
+        if(task == current)
+        {
+                len = get_intarr(filp, buf, cnt, &ctl);
+                if (len < 0)
+                        return (len);
+                mig_set_miggroup(miggroup);
+                return (len);
+        }
+        if(!suser())
+                return(-EPERM);
+        len = get_intarr(filp, buf, cnt, &ctl);
+        if(len < 0)
+                return(len);
+        task_lock(task);
+        task->mosix.mask.miggroup = miggroup;
+        task_unlock(task);
+        return(len);
+}
+
+
+
+ssize_t
+proc_mosix_pid_set_disclosure(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int disclosure, len;
+	struct ctl_mosix ctl =
+		{ 0, "disclosure", NULL, sizeof(int), 0, ctl_minmaxv };
+
+	ctl.data = (void *)&disclosure;
+	ctl.extra[0] = (void *) 0;
+	ctl.extra[1] = (void *) 3;
+
+	if(task != current)
+		return(-EPERM);
+	len = get_intarr(filp, buf, cnt, &ctl);
+	if (len < 0)
+		return (len);
+	current->mosix.disclosure = disclosure;
+	tell_process(current, DREQ_INFOCNG);
+	return(len);
+}
+
+ssize_t
+proc_mosix_pid_set_sigmig(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int sig = current->mosix.sigmig, len;
+	struct ctl_mosix tmpctl =
+		{ 0, "sigmig", NULL, sizeof(int), 0, ctl_minmaxv };
+
+	if(task != current)
+		return(-EPERM);
+
+	tmpctl.data = &sig;
+	tmpctl.extra[0] = (void *) 0;
+	tmpctl.extra[1] = (void *) _NSIG;
+	len = get_intarr(filp, buf, cnt, &tmpctl);
+	if(len >= 0)
+		current->mosix.sigmig = sig;
+	return (len);
+}
+
+#ifdef CONFIG_MOSIX_FS
+ssize_t
+proc_mosix_pid_set_selected(struct file *filp, struct task_struct *task,
+						const char *buf, size_t cnt)
+{
+	int sel, len;
+	struct ctl_mosix ctl =
+		{ 0, "lock", NULL, sizeof(int), 0, ctl_minmaxv };
+
+	if(task != current)
+		return(-EPERM);
+
+	ctl.data = (void *) &sel;
+	ctl.extra[0] = (void *) 0;
+	ctl.extra[1] = (void *) MOSIX_MAX;
+	sel = current->mosix.selected;
+	len = get_intarr(filp, buf, cnt, &ctl);
+	if (len >= 0 && sel != current->mosix.selected)
+	{
+		current->mosix.selected = sel;
+#ifdef CONFIG_MOSIX_DFSA
+		current->mosix.dupdates |= DFSA_UPDSEL;
+#endif /* CONFIG_MOSIX_DFSA */
+	}
+	return (len);
+}
+#endif /* CONFIG_MOSIX_FS */
+
+static ssize_t
+proc_mosix_set_remote_goto(struct file *filp, int pid,
+			   const char *buf, size_t cnt)
+{
+	struct task_struct *task;
+	int error, whereto;
+	struct ctl_mosix tmpctl =
+		{ 0, "goto", NULL, sizeof(int), 0, ctl_minmaxv };
+
+	if(!suser())
+		return(-EACCES);
+	read_lock(&tasklist_lock);
+	task = find_any_task_by_pid(pid);
+	if(task && !(task->mosix.dflags & DREMOTE))
+		task = NULL;
+	if(task)
+		get_task_struct(task);
+	read_unlock(&tasklist_lock);
+	if (!task)
+		return(-EBADF);
+
+	tmpctl.data = &whereto;
+	tmpctl.extra[0] = (void *) DM_BALANCE;
+	tmpctl.extra[1] = (void *) MOSIX_MAX;
+	error = get_intarr(filp, buf, cnt, &tmpctl);
+	if (error < 0)
+		goto free;
+	if(whereto > 0)
+	{
+		error = -ENODEV;
+		if(!mos_to_net(whereto, NULL))
+			goto free;
+	}
+	else switch(whereto)
+	{
+	case DM_GOBACKHOME:
+		whereto = GOBACKHOME;
+		break;
+	case DM_BALANCE:
+		whereto = BALANCE;
+		break;
+	default:
+		mosix_panic("remote_goto: invalid negative");
+	}
+
+	lock_mosix();
+	if(!(task->mosix.dflags & DFINISHED))
+		mosix_add_to_whereto(task, whereto);
+	unlock_mosix();
+	error = 0;
+	free:
+	free_task_struct(task);
+	return (error);
+}
+
+static int
+proc_mosix_get_remote_from(struct task_struct *task, char *buf)
+{
+	int node;
+	int len;
+
+	node = task->mosix.deppe;
+	sprintf(buf, "%-6d", node);
+	if (mos_to_ascii(node, buf + 6, 1000) < 0) {
+		return (-EDIST);
+	}
+	len = strlen(buf);
+	buf[len++] = '\n';
+	return (len);
+}
+
+static int
+proc_mosix_get_remote_stats(struct task_struct *tsk, char *buf)
+{
+	struct mm_struct *mm;
+	struct vm_area_struct *vma;
+	unsigned long vsize;
+	unsigned long s = LOGICAL_STATE(tsk);
+	char state;
+
+	if(s == TASK_RUNNING)
+		state = 'R';
+	else if(s & TASK_INTERRUPTIBLE)
+		state = 'S';
+	else if(s & TASK_UNINTERRUPTIBLE)
+		state = 'D';
+	else
+	{
+		printk("Oops, remote-status = 0x%lx\n", s);
+		state = '?';
+	}
+	vsize = 0;
+	mm = tsk->mm;
+	if (mm && mm != &init_mm)
+	{
+		down_read(&mm->mmap_sem);
+		for(vma = mm->mmap ; vma ; vma = vma->vm_next)
+			vsize += vma->vm_end - vma->vm_start;
+		up_read(&mm->mmap_sem);
+	}
+
+	return(sprintf(buf, "utime=%lu\ncutime=%lu\n"
+			"nice=%ld\nstate=%c\nvsize=%lu\nrss=%lu\n"
+			"nswap=%lu\ncnswap=%lu\n",
+		(unsigned long)(tsk->times.tms_utime + tsk->mosix.uttime),
+		(unsigned long)(tsk->times.tms_cutime + tsk->mosix.cutime),
+		tsk->nice,
+		state,
+		vsize,
+		tsk->mm ? tsk->mm->rss : 0,
+		tsk->nswap,
+		tsk->cnswap) + 1);
+}
+
+static int
+proc_mosix_get_remote_identity(struct task_struct *tsk, char *buf)
+{
+	char *obuf = buf;
+
+	buf[0] = '\0';
+	if(tsk->mosix.disclosure)
+	{
+		buf += sprintf(buf, "pid=%d\n", tsk->mosix.mypid);
+		if(tsk->mosix.depinfo.tgid != tsk->mosix.mypid)
+			buf += sprintf(buf, "tgid=%d\n",
+						tsk->mosix.depinfo.tgid);
+	}
+	if(tsk->mosix.disclosure > 1)
+		buf += sprintf(buf, "uid=%d\ngid=%d\n", tsk->uid, tsk->gid);
+	if(tsk->mosix.disclosure > 2)
+		buf += sprintf(buf, "pgrp=%d\nsession=%d\nnmigs=%d\ncommand=%.16s\n",
+			tsk->mosix.depinfo.pgrp, tsk->mosix.depinfo.session,
+			tsk->mosix.nmigs, tsk->mosix.depinfo.comm);
+	return(buf - obuf);
+}
